package net.afyre.haha.demo.coq;

/**
 * The class that controls different kinds of indentation.
 * 
 * @author Aleksy Schubert <alx@mimuw.edu.pl>
 */
import java.io.Writer;
import java.util.ListIterator;
import java.util.Stack;


/**
 * 
 * @author Aleksy Schubert <alx@mimuw.edu.pl>
 *
 */
public class CoqIndent {
	
	
	
    /** The output to write the indentation to */
	private Writer output;
	
	/** The level of indentation */
	private Stack<IndentItem> level;

	public CoqIndent(Writer output) {
		this.output = output;
		this.level = new Stack<IndentItem>();
	}

	public void print() {
		ListIterator<IndentItem> i = level.listIterator();
		while (i.hasNext()) {
			IndentItem e = i.next();
			e.print();
		}
	}

	/**
	 * Pushes the default indentation object on the stack
	 * of indentations.
	 */
	public void inc() {
		level.push(new DefaultIndent(output));
	}

	/** Pops the indentation object. It does not check if the
	 *  indentation stack is empty.
	 */
	public void dec() {
		level.pop();
	}

}
