package net.afyre.haha.demo.coq;

/**
 * 
 * @author Aleksy Schubert <alx@mimuw.edu.pl>
 *
 */
public class CoqLanguage {
	  private static final String[] coqreserved = {
		  "_", "as", "at", "cofix", "else", "end",
		  "exists", "exists2", "fix", "for", "forall", "fun",
		  "if", "IF", "in", "let", "match", "mod",
		  "Prop", "return", "Set", "then", "Type", "using",
		  "where", "with"
	  };

	
	  /**
	   * Turn the name to the format acceptable as a Coq identifier
	   * name. 
	   * 
	   * @param name the name to change
	   * @return the resulting name
	   */
	public static String coqifyName(String nameS) {
		StringBuffer name = new StringBuffer(nameS);
		if (name.charAt(name.length()-1) == '?')
			name.replace(name.length()-1, name.length(), "P");
		replaceForbidden(name, "-", "_");
		replaceForbidden(name, "@", "__");
		if (isCoqReservedName(name.toString())) {
			name.append("_");
		}

		return name.toString();
	}

	private static void replaceForbidden(StringBuffer name, String forb, 
			String res) {
		for (int i=name.indexOf(forb); i>=0; i=name.indexOf(forb)) {
			name.replace(i, i+forb.length(), res);
		}
	}

	public static boolean isCoqReservedName(String name) {
		for (int i = 0; i<coqreserved.length; i++) {
			if (name.equals(coqreserved[i])) {
				return true;
			}
		}
		return false;
	}
}