package net.afyre.haha.demo.coq;

import java.io.IOException;
import java.io.Writer;

/**
 * Default kind of indentation.
 * 
 * @author Aleksy Schubert <alx@mimuw.edu.pl>
 *
 */
public class DefaultIndent implements IndentItem {
	
	

	/** The size of the indent. */
	private static final int DEFAULT_INDENT_SIZE = 2;
	
	/** The output to write the indent to */
	private Writer output;

	/** The indentation String to be written */ 
	private String indentString;
	
	/**
	 * Constructor that fixes the output to write to and
	 * creates the indentation string.
	 * 
	 * @param output the output to write to
	 */
	public DefaultIndent(Writer output) {
		this.output = output;
		StringBuffer buf = new StringBuffer(DEFAULT_INDENT_SIZE);
		for (int i = 0; i < DEFAULT_INDENT_SIZE; i++ ) {
			buf.append(' ');
		};
		this.indentString = buf.toString();
	}

	@Override
	public int getLength() {
		return DEFAULT_INDENT_SIZE;
	}

	@Override
	public void print() {
		try {
			output.write(indentString);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}

}
