package net.afyre.haha.demo.rcp;

import java.util.HashSet;
import java.util.Set;

import org.eclipse.core.commands.Command;
//import org.eclipse.core.commands.ExecutionEvent;
//import org.eclipse.core.commands.ExecutionException;
//import org.eclipse.core.commands.IExecutionListener;
//import org.eclipse.core.commands.NotHandledException; 
import org.eclipse.core.runtime.ILog;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.jface.preference.IPreferenceNode;
import org.eclipse.jface.preference.PreferenceManager;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.application.IWorkbenchWindowConfigurer;
import org.eclipse.ui.application.WorkbenchAdvisor;
import org.eclipse.ui.application.WorkbenchWindowAdvisor;
import org.eclipse.ui.commands.ICommandService;
import org.eclipse.ui.contexts.IContextService;
//import org.eclipse.ui.handlers.IHandlerService;

import net.afyre.haha.demo.rcp.hacks.DisabledHandler;

public class ApplicationWorkbenchAdvisor extends WorkbenchAdvisor {

  private final ILog log = Activator.getDefault().getLog();
  
  private static final String PERSPECTIVE_ID = "net.afyre.haha.demo.rcp.perspective"; //$NON-NLS-1$

  private static final String[] commandBlacklist = new String[] {
    //"org.eclipse.ui.newWizard"
  };
  
  private static final String[] allowedPreferencePages = new String[] {
		  "org.eclipse.ui.preferencePages.Workbench",
		  "org.eclipse.ui.preferencePages.Views",
		  "org.eclipse.ui.preferencePages.ColorsAndFonts",
		  "org.eclipse.ui.preferencePages.Decorators",
		  "org.eclipse.compare.internal.ComparePreferencePage",
		  "org.eclipse.ui.preferencePages.Editors",
		  "org.eclipse.ui.preferencePages.AutoSave",
		  "org.eclipse.ui.preferencePages.FileEditors",
		  "org.eclipse.ui.preferencePages.GeneralTextEditor",
		  "org.eclipse.ui.editors.preferencePages.Accessibility",
		  "org.eclipse.ui.editors.preferencePages.Annotations",
		  "org.eclipse.ui.editors.preferencePages.HyperlinkDetectorsPreferencePage",
		  "org.eclipse.ui.editors.preferencePages.LinkedModePreferencePage",
		  "org.eclipse.ui.editors.preferencePages.QuickDiff",
		  "org.eclipse.ui.editors.preferencePages.Spelling",
		  "net.afyre.haha.demo.Haha",
		  "net.afyre.haha.demo.Haha.coloring",
		  "net.afyre.haha.demo.Haha.templates",
		  "net.afyre.haha.demo.ui.prefs.solver",
		  "net.afyre.haha.demo.ui.prefs.coq",
		  "org.eclipse.help.ui.browsersPreferencePage",
		  "org.eclipse.help.ui.contentPreferencePage"
  };
  
  public WorkbenchWindowAdvisor createWorkbenchWindowAdvisor(
      IWorkbenchWindowConfigurer configurer) {
    return new ApplicationWorkbenchWindowAdvisor(configurer);
  }

  public String getInitialWindowPerspectiveId() {
    return PERSPECTIVE_ID;
  } 
  
  @Override
  public void postStartup() {
    super.postStartup();
    
    PreferenceManager pm = PlatformUI.getWorkbench().getPreferenceManager( );

    
    for (IPreferenceNode a : pm.getElements(0)) {
    	String id =a.getId();
    	//This code can be used to check which is the id of the preference page
    	//System.out.println(a.getLabelText());
    	//System.out.println(id);
    	boolean was = false;
    	for (int i = 0; i < allowedPreferencePages.length; i++) {
			if (allowedPreferencePages[i].compareTo(id)==0) {
				was = true;
				break;
			}
		}
    	if (!was) {
    		pm.remove(id);
    	}
    }
    
    IContextService contextService = (IContextService) PlatformUI.getWorkbench().getService(IContextService.class);
    contextService.activateContext("eclipse.sucks");
    
    final Set<String> blacklist = new HashSet<String>(commandBlacklist.length);
    for (final String id : commandBlacklist) {
      blacklist.add(id);
    }
    
    final IWorkbench workbench = getWorkbenchConfigurer().getWorkbench();
    final ICommandService commandService = 
        (ICommandService) workbench.getService(ICommandService.class);
    for (final Command cmd : commandService.getDefinedCommands()) {
      if (blacklist.contains(cmd.getId())) {
        log.log(new Status(IStatus.INFO, Activator.PLUGIN_ID, 
            "Disabling handler for command: " + cmd.getId()));
        cmd.setHandler(DisabledHandler.getInstance());
      }
      /*cmd.addExecutionListener(new IExecutionListener() {
        
        @Override
        public void preExecute(String commandId, ExecutionEvent event) {
          log.log(new Status(IStatus.INFO, Activator.PLUGIN_ID, 
              "Executing command " + commandId));
        }
        
        @Override
        public void postExecuteSuccess(String commandId, Object returnValue) {
          // TODO Auto-generated method stub
          
        }
        
        @Override
        public void postExecuteFailure(String commandId, ExecutionException exception) {
          // TODO Auto-generated method stub
          
        }
        
        @Override
        public void notHandled(String commandId, NotHandledException exception) {
          // TODO Auto-generated method stub
          
        }
      });*/
    }
  }
  
}
