package net.afyre.haha.demo.solver.context;

import java.io.StringWriter;

/**
 * Abstract superclass of declarations.
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 *
 */
public abstract class AbstractDeclaration implements Declaration {
  /** Symbol name. */
  private final String name;
  
  /**
   * Constructor.
   * @param name Name of the declared symbol or axiom.
   */
  public AbstractDeclaration(final String name) {
    this.name = name;
  }

  /** {@inheritDoc} */
  @Override
  public String getName() {
    return name;
  }
  
  /** {@inheritDoc} */
  @Override
  public String toString() {
    final StringWriter buffer = new StringWriter();
    final DeclarationPrinter printer = new DeclarationPrinter(buffer);
    accept(printer);
    return buffer.toString();
  }
}
