package net.afyre.haha.demo.solver.expr.formulae.impl;

import java.util.Arrays;

import net.afyre.haha.demo.solver.expr.formulae.FormulaSwitch;
import net.afyre.haha.demo.solver.expr.terms.Term;

/**
 * Pairwise inequality test.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 *
 */
public final class Distinct extends AbstractFormula {
  /** Arguments. */
  private final Term[] arguments;

  /**
   * Constructor.
   * @param arguments Arguments.
   */
  public Distinct(final Term[] arguments) {
    this.arguments = Arrays.copyOf(arguments, arguments.length);
  }
  
  /**
   * Get the arguments.
   * @return Arguments.
   */
  public Term[] getArguments() {
    return Arrays.copyOf(arguments, arguments.length);
  }

  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final FormulaSwitch<? extends Result> v) {
    return v.caseDistinct(Arrays.copyOf(arguments, arguments.length));
  }
}
