package net.afyre.haha.demo.solver.expr.terms.impl;

import net.afyre.haha.demo.solver.expr.terms.Term;
import net.afyre.haha.demo.solver.expr.terms.TermSwitch;

/**
 * Unary minus.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 *
 */
public final class Uminus extends AbstractTerm {
  /** Argument. */
  private final Term argument;
  
  /**
   * Constructor.
   * @param argument Argument.
   */
  public Uminus(final Term argument) {
    this.argument = argument;
  }
  
  /**
   * Get the argument.
   * @return Argument.
   */
  public Term getArgument() {
    return argument;
  }

  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final TermSwitch<? extends Result> v) {
    return v.caseUminus(argument);
  }
}
