package net.afyre.haha.demo.solver.expr.terms.impl;

import net.afyre.haha.demo.solver.expr.terms.TermSwitch;

/**
 * Variable reference.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public final class Variable extends AbstractTerm {
  /** Variable name. */
  private final String name;
  
  /**
   * Constructor.
   * @param name Variable name.
   */
  public Variable(final String name) {
    this.name = name;
  }
  
  /**
   * Get the variable name.
   * @return Name.
   */
  public String getName() {
    return name;
  }

  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final TermSwitch<? extends Result> v) {
    return v.caseVariable(name);
  }
}
