package net.afyre.haha.demo.solver.expr.types.impl;

import net.afyre.haha.demo.solver.expr.types.AtomicTypeSwitch;

/**
 * Bit vectors.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public final class Bitvector extends AbstractAtomicType {
  /** Vector size. */
  private final int size;
  
  /**
   * Constructor.
   * @param size Vector size.
   */
  public Bitvector(final int size) {
    this.size = size;
  }
  
  /**
   * Get vector size.
   * @return Size.
   */
  public int getSize() {
    return size;
  }

  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final AtomicTypeSwitch<? extends Result> v) {
    return v.caseBitvector(size);
  }
  
}
