package net.afyre.haha.demo.ui;

import java.util.Map;
import java.util.TreeMap;

import org.eclipse.ui.AbstractSourceProvider;
import org.eclipse.ui.ISources;

/**
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 *
 */
public class HahaSourceProvider extends AbstractSourceProvider {
  public static final String VAR_RUNNING = "net.afyre.haha.demo.ui.vcgenRunning";
  public static final String VAR_THREAD = "net.afyre.haha.demo.ui.vcgenThread";
  
  private boolean running = false;
  private Thread thread;
  
  public HahaSourceProvider() {
    
  }
  
  /** {@inheritDoc} */
  @Override
  public void dispose() {
  }

  /** {@inheritDoc} */
  @SuppressWarnings({ "rawtypes", "unchecked" })
  @Override
  public Map getCurrentState() {
    final TreeMap result = new TreeMap();
    result.put(VAR_RUNNING, running);
    result.put(VAR_THREAD, thread);
    return result;
  }

  /** {@inheritDoc} */
  @Override
  public String[] getProvidedSourceNames() {
    return new String[] { VAR_RUNNING, VAR_THREAD };
  }

  public Thread getThread() {
    return thread;
  }
  
  public void setRunning(final boolean running) {
    this.running = running;
    fireSourceChanged(ISources.WORKBENCH, VAR_RUNNING, running);
  }
  
  public void setThread(final Thread thread) {
    this.thread = thread;
    fireSourceChanged(ISources.WORKBENCH, VAR_THREAD, thread);
  }
}
