package net.afyre.haha.demo.ui.handler;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.console.IConsoleConstants;
import org.eclipse.ui.handlers.HandlerUtil;

/**
 * The class implements the command to show the Console.
 * 
 * @author Aleksy Schubert <alx@mimuw.edu.pl>
 *
 */
public class ConsoleShowHandler extends AbstractHandler implements IHandler {

	/**
	 * The method retrieves the id for the console and opens it in the
	 * view of the current event.
	 * 
	 * @param event that caused the execution of the command
	 */
	@Override
	public Object execute(ExecutionEvent event) throws ExecutionException {
	    final IWorkbenchWindow window = 
	    		HandlerUtil.getActiveWorkbenchWindowChecked(event);
	    final IWorkbenchPage page = window.getActivePage();
	    String id = IConsoleConstants.ID_CONSOLE_VIEW;
		try {
			page.showView(id);
		} catch (PartInitException e) {
			final Shell shell = HandlerUtil.getActiveShellChecked(event);
			MessageBox dialog = new MessageBox(shell,SWT.OK);
			dialog.setMessage("Cannot show the Console");
			dialog.open();
		}
		return null;
	}

}
