package net.afyre.haha.demo.ui.util;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parsetree.reconstr.Serializer;

import com.google.inject.Guice;

import net.afyre.haha.demo.HahaRuntimeModule;
import net.afyre.haha.demo.haha.Type;

/**
 * Static utility methods.
 */
public final class Utils {
  private Utils(){}
  
  private static Serializer serializer;
  
  private static Serializer getSerializer() {
    if (serializer == null) {
      serializer = 
          Guice.createInjector(new HahaRuntimeModule())  
           .getInstance(Serializer.class);  
     }  
     return serializer;      
  }
  
  /**
   * Serialize (convert to text) a model element.
   * @param elem Model element.
   * @return Textual representation.
   */
  public static String serialize(final EObject elem) {
    return getSerializer().serialize(elem);
  }
  
  /**
   * Create a human-readable description of a type.
   * @param type Type object.
   * @return Text string.
   */
  public static String typeToString(final Type type) {
    return type.asString();
  }
}
