package net.afyre.haha.demo.ui.vcview;

import net.afyre.haha.demo.vcgen.tree.ConditionNode;
import net.afyre.haha.demo.vcgen.tree.ContextNode;
import net.afyre.haha.demo.vcgen.tree.Node;
import net.afyre.haha.demo.vcgen.tree.NodeSwitch;

import org.eclipse.jface.viewers.LabelProvider;

/**
 * Label provider for the tree of verifcation conditions.
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public class VCTreeLabelProvider extends LabelProvider {
  private final LabelSwitch labelSwitch = new LabelSwitch();
  
  /** {@inheritDoc} */
  @Override
  public String getText(final Object element) {
    final Node node = (Node)element;
    
    return node.doSwitch(labelSwitch);
  }

  private static class LabelSwitch implements NodeSwitch<String> {

    /** {@inheritDoc} */
    @Override
    public String caseContext(final ContextNode node) {
      return node.getContext().getComment();
    }

    /** {@inheritDoc} */
    @Override
    public String caseCondition(final ConditionNode node) {
      return node.getCondition().getGoal().getName();
    }
  }
  
}
