package net.afyre.haha.demo.ui.vcview;

import net.afyre.haha.demo.vcgen.tree.ContextNode;
import net.afyre.haha.demo.vcgen.tree.Node;

import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

/**
 * Tree provider for trees of verification conditions.
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 *
 */
public class VerificationConditionsTree implements ITreeContentProvider {

  /** {@inheritDoc} */
  @Override
  public void dispose() {
    // ???
  }

  /** {@inheritDoc} */
  @Override
  public void inputChanged(final Viewer viewer, 
                           final Object oldInput, 
                           final Object newInput) {
    // ???
  }

  /** {@inheritDoc} */
  @Override
  public Object[] getElements(final Object inputElement) {
    final Node root = (Node)inputElement;
    
    return root.getChildren().toArray();
  }

  /** {@inheritDoc} */
  @Override
  public Object[] getChildren(final Object parentElement) {
    final Node node = (Node)parentElement;
    
    return node.getChildren().toArray();
  }

  /** {@inheritDoc} */
  @Override
  public Object getParent(final Object element) {
    final Node node = (Node)element;
    
    // Hide the root node
    if (node.getParent().getParent() == null) {
      return null;
    } else {
      return node.getParent();
    }
  }

  /** {@inheritDoc} */
  @Override
  public boolean hasChildren(final Object element) {
    return element instanceof ContextNode;
  }

}
