package net.afyre.haha.demo.util.tests;

import static org.junit.Assert.*;

import java.util.Iterator;

import net.afyre.haha.demo.util.EmptyIterable;

import org.junit.Test;

/**
 * Tests for the {@link EmptyIterable} class.
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 * @see EmptyIteratorTest
 */
public class EmptyIterableTest {

  /** GetInstance does not return null. */
  @Test
  public void testInstanceNotNull() {
    final EmptyIterable<?> iterable = EmptyIterable.getInstance();
    assertNotNull("Null returned from getInstance()", iterable);
  }

  /** Iterator is not null. */
  @Test
  public void testIteratorNotNull() {
    final EmptyIterable<?> iterable = EmptyIterable.getInstance();
    final Iterator<?> it = iterable.iterator();
    assertNotNull("Null iterator returned", it);
  }
  
  /** HasNext() in iterator returns false. */
  @Test
  public void testHasNextIsFalse() {
    final EmptyIterable<?> iterable = EmptyIterable.getInstance();
    final Iterator<?> it = iterable.iterator();
    assertFalse("HasNext() returned wrong result", it.hasNext());
  }

}
