package net.afyre.haha.demo.util;

import java.util.Iterator;

/**
 * Collection with no elements.
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 * 
 * @param <T> Type of elements.
 */
public class EmptyIterable<T> implements Iterable<T> {
  /** Constructor. */
  private EmptyIterable() { }
  
  /**
   * Create an empty iterator.
   * @param <T> Type of elements.
   * @return Iterator instance.
   */
  public static<T> EmptyIterable<T> getInstance() {
    return new EmptyIterable<T>();
  }

  /** {@inheritDoc} */
  @Override
  public Iterator<T> iterator() {
    return EmptyIterator.getInstance();
  }
}
