package net.afyre.haha.demo.util;

/**
 * Interface of unary functions.
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 * 
 * @param <Arg> Domain.
 * @param <Result> Codomain.
 */
public interface Function<Arg, Result> {
  /**
   * Apply the function to an argument.
   * @param arg Argument.
   * @return Result.
   */
  Result apply(Arg arg);
}
