package net.afyre.haha.demo.util;

/**
 * Interface of objects used to calculate hash values
 * for sequences of octets.
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public interface HashBuilder {
  /**
   * Append a byte to the hashed sequence.
   * @param b Byte value.
   */
  void appendByte(final byte b);
  
  /**
   * Append an integer to the hashed sequence.
   * Big-endian ordering is used when encoding 
   * the integer as a sequence of octets.
   * @param i Integer value.
   */
  void appendInt(int i);
    
  /**
   * Clear the hashed sequence.
   */
  void reset();
}
