package net.afyre.haha.demo.types;

/**
 * Interface of types that can be assigned to variables
 * bound by quantifiers.
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public interface AtomicType extends ValueType {
  /**
   * Deconstruct this type using a switch.
   * 
   * @param <Result> Type of objects returned by the switch.
   * @param sw Switch object.
   * @return Object returned by the switch.
   */
  <Result> Result doSwitch(AtomicTypeSwitch<? extends Result> sw);
}
