package net.afyre.haha.demo.vcgen;

import java.util.List;

import net.afyre.haha.demo.haha.HoareTriple;

/**
 * Interface of verification condition generators
 * for single Hoare triples.
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public interface HoareTripleVCGen {
  /**
   * Generate verification conditions for a statement.
   * @param context Parent context for generated conditions.
   * @param preconditions List of preconditions.
   * @param stmt Statement.
   * @param postconditions List of postconditions.
   * @param consumer Object used to process generated conditions.
   */
  void generateVerificationConditions(
      VCContext context,
      List<DocumentedFormula> preconditions,
      HoareTriple stmt,
      List<DocumentedFormula> postconditions, 
      VCConsumer consumer);
}
